package bookExamples.ch26Graphics.draw2d;

import java.awt.*;
import java.awt.geom.Point2D;
import java.awt.geom.Line2D;
import java.awt.geom.QuadCurve2D;

public class Rhombus2d extends Shape {
    int h = 1;
    int w = 1;
    int xc = 0;
    int yc = 0;

    public Shape getInstance(int x1, int y1, int x2, int y2) {
        return new Rhombus2d(x1, y1, x2, y2);
    }

    public int getX() {
        return x1;
    }

    public int getY() {
        return y1;
    }

    public int getW() {
        return w;
    }

    public int getH() {
        return h;
    }


    public Rhombus2d(int _x1, int _y1, int _x2, int _y2) {
        super(_x1, _y1, _x2, _y2);
        setX1(_x1);
        setY1(_y1);
        w = Math.abs(_x2 - x1);
        h = Math.abs(_y2 - y1);
        if (_x1 > _x2) setX1(_x2);
        if (_y1 > _y2) setY1(_y2);
        xc = x1 + w / 2;
        yc = y1 + h / 2;

    }

    public void paint(Graphics g) {
        saveState(g);

        Point2D p1 = new Point2D.Float(x1+h, y1);
        Point2D p2 = new Point2D.Float(x1 + w+h, y1);
        Point2D p3 = new Point2D.Float(x1 + w, y1 + h);
        Point2D p4 = new Point2D.Float(x1, y1 + h);

        drawLine(p1, p2, g);
        drawLine(p2, p3, g);
        drawLine(p3, p4, g);
        drawLine(p4, p1, g);
        g.fillOval(xc, yc, 2, 2);
        g.drawString("(" + xc + "," + yc + ")", xc + 3, yc + 3);
        restoreState(g);
    }
}
